-- Author      : Mmoose
-- Create Date : 20090818
local addon = Ei
--system functions
function Ei:PLAYER_ENTERING_WORLD()
	Ei.create_mmButton()
end
function Ei:MAIL_SEND_SUCCESS()
	if(Ei.working == true) then
		DEFAULT_CHAT_FRAME:AddMessage(EiLOC["ist"].." "..Ei.recv)
		Ei.good = true
		Ei.ind = Ei.ind+1
		Ei.SendInvitations()
	end
end
function Ei:MAIL_FAILED()
	if(Ei.working == true) then
		if(Ei.good == false) then
			DEFAULT_CHAT_FRAME:AddMessage(EiLOC["ifst"].." "..Ei.recv)
			Ei.ind = Ei.ind+1
		else
			Ei.good = false
		end	
		Ei.SendInvitations()
	end
end
function Ei:CALENDAR_OPEN_EVENT()
	if(addon.EiCEButton) then
	else
		Ei.EiCEButton = CreateFrame("Button", nil, nil, "UIPanelButtonTemplate")
		Ei.EiCEButton:SetParent(CalendarCreateEventFrame)
		Ei.EiCEButton:SetWidth(130)
		Ei.EiCEButton:SetHeight(20)
		Ei.EiCEButton:SetText(EiLOC["prepare"])
		Ei.EiCEButton:SetScript("OnClick", function() Ei.PrepareInvitations() end)
		Ei.EiCEButton:SetPoint("RIGHT", CalendarCreateEventFrame, "RIGHT", -10, 0)
		Ei.EiCEButton:SetPoint("TOP", CalendarCreateEventFrame, "TOP", 0, -125)	
	end
	

end
function Ei:MAIL_SHOW()
	if(addon.EiMFButton) then
	else
		Ei.EiMFButton = CreateFrame("Button", nil, nil, "UIPanelButtonTemplate")
		Ei.EiMFButton:SetParent(MailFrame)
		Ei.EiMFButton:SetWidth(130)
		Ei.EiMFButton:SetHeight(20)
		Ei.EiMFButton:SetText(EiLOC["send"])
		Ei.EiMFButton:SetScript("OnClick", function() Ei.GatherInvitations() end)
		Ei.EiMFButton:SetPoint("RIGHT", MailFrame, "RIGHT", -40, 0)
		Ei.EiMFButton:SetPoint("TOP", MailFrame, "BOTTOM", 0, 75)	
	end	
	if(Ei.invprepared == true) then
		Ei.EiMFButton:Show()
	else
		Ei.EiMFButton:Hide()
	end
end
function Ei:GetEType(n)
	if(n == 1) then
		return EiLOC["raid"]
	elseif(n == 2) then
		return EiLOC["dungeon"]
	elseif(n == 3) then
		return EiLOC["pvp"]
	elseif(n == 4) then
		return EiLOC["meeting"]
	elseif(n == 5) then
		return EiLOC["other"]
	end
end
--
function Ei:PrepareInvitations()
	--basic information on the event opened
	local title, description, creator, eventType, repeatOption, maxSize, textureIndex, weekday, month, day, year, hour, minute, lockoutWeekday, lockoutMonth, lockoutDay, lockoutYear, lockoutHour, lockoutMinute, locked, autoApprove = CalendarGetEventInfo()
	--fix event type here
	--types are
	--1 - raid
	--2 - dungeon
	--3 - pvp
	--4 - meeting
	--5 - other
	eventType = Ei:GetEType(eventType)
	--finish fixing event type
	--get event index here
	local mo, d, index = CalendarGetEventIndex()
	--pass it to get names and other
	local name, calendarType, raidID, hour, minute, difficulty = CalendarGetRaidInfo(mo, d, index)
	Ei.invdta = {}
	Ei.invdta.title = title
	Ei.invdta.etype = eventType
	Ei.invdta.description = description
	Ei.invdta.weekday = weekday
	Ei.invdta.month = month
	Ei.invdta.day = day
	Ei.invdta.year = year
	Ei.invdta.hour = hour
	Ei.invdta.minute = minute
	Ei.invdta.attendees = {}	  	
	for i=1, CalendarEventGetNumInvites() do
		local cname, level, className, classFilename, inviteStatus, modStatus = CalendarEventGetInvite(i)
		if(cname == UnitName("player")) then
		else
			table.insert(Ei.invdta.attendees, cname)
		end
	end
	Ei.invprepared = true
	Ei.mmLayerBack:SetTexture("Interface\\Icons\\INV_letter_03")
end

function Ei:GatherInvitations()
	local su, m, t, w, th, f, sa =  CalendarGetWeekdayNames()
	table.insert(Ei.dys, su)
	table.insert(Ei.dys, m)
	table.insert(Ei.dys, t)
	table.insert(Ei.dys, w)
	table.insert(Ei.dys, th)
	table.insert(Ei.dys, f)
	table.insert(Ei.dys, sa)
	
	Ei.invdta.weekday = Ei.dys[Ei.invdta.weekday]
	--build body of message here
	
	Ei.msg = addon.db.profile.itextdef
	Ei.msg = Ei.msg.."\r\n"
	--Ei.msg = Ei.msg.."Details of this event are:"
	Ei.msg = Ei.msg.."\r\n"
	Ei.msg = Ei.msg..EiLOC["Title"].." "..Ei.invdta.title
	Ei.msg = Ei.msg.."\r\n"
	Ei.msg = Ei.msg..EiLOC["Type"].." "..Ei.invdta.etype
	Ei.msg = Ei.msg.."\r\n"
	Ei.msg = Ei.msg..EiLOC["Description"].." "..Ei.invdta.description
	if(addon.db.profile.iappend == true) then
		Ei.msg = Ei.msg.."\r\n"
		Ei.msg = Ei.msg..EiLOC["checkcal"]
	end		

	Ei.ind = 1	
	Ei.SendInvitations()

end
function Ei:SendInvitations()
	if(Ei.invdta.attendees[Ei.ind] ~= nil) then
		Ei.working = true
		local v = Ei.invdta.attendees[Ei.ind]
		Ei.recv = v
		SendMail(v, addon.db.profile.isubjdef, Ei.msg)
		return
	else
		Ei.invdta = ""
		Ei.invdta = {}
		Ei.invprepared = false
		Ei.mmLayerBack:SetTexture("Interface\\Icons\\INV_misc_giftwrap_02")
		DEFAULT_CHAT_FRAME:AddMessage(EiLOC["istdone"])
		Ei.working = false		
	end
end

function Ei:mmButton_toggle()
	if(Ei.mmButton:IsVisible()) then
		Ei.mmButton:Hide()
	else
		Ei.mmButton:Show()
	end
end
function Ei.mmButton_reposition()
	Ei.mmButton:RegisterForClicks("AnyUp")
	if(addon.db.profile.MiniMapPos == nil) then
		addon.db.profile.MiniMapPos = 320.0
	end
	if(addon.db.profile.MiniMapRad == nil) then
		addon.db.profile.MiniMapRad = 80
	end
	Ei.mmButton:SetPoint("TOPLEFT","Minimap","TOPLEFT",54-(addon.db.profile.MiniMapRad*cos(addon.db.profile.MiniMapPos)),(addon.db.profile.MiniMapRad*sin(addon.db.profile.MiniMapPos))-55)
end
function Ei:mmButton_TT_Show()
	CreateFrame("GameTooltip", "Eimytip", UIParent, "GameTooltipTemplate")
	Eimytip:SetOwner(Minimap, "ANCHOR_BOTTOMLEFT")	
	Eimytip:AddLine(EiLOC["versionstring"], 1, 0, 0)
	Eimytip:AddLine("-------------------", 1, 0, 0)

	if(Ei.invprepared == true) then
		Eimytip:AddLine(EiLOC["its"])
		Eimytip:AddLine(EiLOC["lclick"], 0, 1, 0)
	else
		Eimytip:AddLine(EiLOC["nits"])
	end
	Eimytip:Show();
end
function Ei:mmButton_TT_Hide()
	Eimytip:Hide();
end
function Ei:create_mmButton()
	if (not Ei.mmButton) then
		Ei.mmButton = CreateFrame("Button", "Ei.mmButton", Minimap)
		Ei.mmButton:SetWidth(40)
		Ei.mmButton:SetHeight(40)
		Ei.mmButton:EnableMouse(true)
		Ei.mmButton:EnableKeyboard(true)
		Ei.mmButton:SetMovable(true)
		Ei.mmButton:SetScript("OnClick", function() Ei.mmButton_OnClick() end)
		Ei.mmButton:SetScript("OnEnter", function() Ei.mmButton_TT_Show() end)
		Ei.mmButton:SetScript("OnLeave", function() Ei.mmButton_TT_Hide() end)
	
		Ei.mmLayerOverlay = Ei.mmButton:CreateTexture(nil, "OVERLAY")
		Ei.mmLayerOverlay:SetTexture("Interface\\Minimap\\MiniMap-TrackingBorder")
		Ei.mmLayerOverlay:SetWidth(56)
		Ei.mmLayerOverlay:SetHeight(56)
		Ei.mmLayerOverlay:SetPoint("TOPLEFT", Ei.mmButton)

		Ei.mmLayerBack = Ei.mmButton:CreateTexture(nil, "BACKGROUND")
		Ei.mmLayerBack:SetTexture("Interface\\Icons\\INV_misc_giftwrap_02")
		Ei.mmLayerBack:SetWidth(21)
		Ei.mmLayerBack:SetHeight(21)
		Ei.mmLayerBack:SetPoint("TOPLEFT", Ei.mmButton, 7, -6)
	
		Ei.mmDragFrame = CreateFrame("Frame", nil)
		Ei.mmDragFrame:SetParent( Ei.mmButton )
		Ei.mmDragFrame:SetWidth(33)
		Ei.mmDragFrame:SetHeight(33)
		Ei.mmDragFrame:SetPoint("TOPLEFT", Ei.mmButton, 0, 0)
		Ei.mmDragFrame:Hide();
	
		Ei.mmLayerHighlight = Ei.mmButton:CreateTexture(nil, "HIGHLIGHT")
		Ei.mmLayerHighlight:SetTexture("Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight")
		Ei.mmLayerHighlight:SetBlendMode("ADD")
		Ei.mmLayerHighlight:SetWidth(33)
		Ei.mmLayerHighlight:SetHeight(33)
		Ei.mmLayerHighlight:SetPoint("TOPLEFT", Ei.mmDragFrame)
	
		if(addon.db.profile.usemm == true) then		
			Ei.mmButton:Show()
		else
			Ei.mmButton:Hide()
		end
		Ei.mmButton_reposition()
	end
end
function Ei.mmButton_OnClick()
	if(Ei:IsEnabled()) then
		if(arg1 == "LeftButton") then
			if(IsShiftKeyDown()) then
			elseif(IsAltKeyDown()) then
			elseif(IsControlKeyDown()) then
			else
				Ei.invdta = ""
				Ei.invdta = {}
				Ei.invprepared = false
				Ei.mmLayerBack:SetTexture("Interface\\Icons\\INV_misc_giftwrap_02")
			end
		else
			if(IsAltKeyDown()) then
			elseif(IsControlKeyDown()) then
			elseif(IsShiftKeyDown()) then
			else
			end
		end
	else
		if(arg1 == "LeftButton") then
			if(IsControlKeyDown()) then
			elseif(IsAltKeyDown()) then
			end
		end	
	end
end	